# -*- coding: utf-8 -*-

import numpy as np
import matplotlib.pyplot as plt
from ode_solvers import explicit_euler, implicit_euler, implicit_mid_point
from ode45 import ode45

def acceleration(t,y): 

    ############################################
    #                                          #
    #   ex2_c : Implement Sie diese Funktion   #
    #                                          #
    ############################################

    eps = 0.
	omega = 0.

	return 0.

def ODE_rhs(t, y):
    """Rechte Seite der ODE.

       t : Aktuelle Zeit.
       y : 1D Array. Approximative Lösung der Differentialgleichung.
           y[0] : ........
           y[1] : ........
    """

    ############################################
    #                                          #
    #   ex2_c : Implement Sie diese Funktion   #
    #                                          #
    ############################################

    return 0.

def convergence_rate(errors, resolutions):
    """ Berechnet die Konvergenzrate. """
    poly = np.polyfit(np.log(resolutions), np.log(errors), deg=1)
    return -poly[0]

def create_plots(t, y, methodname):

    plt.plot(t, y, label=methodname)
    plt.legend()

    plt.ylabel("Solution")
    plt.xlabel("Time")

def create_log_plots(t, y, methodname):

    plt.loglog(t, y, label=methodname)
    plt.legend()

    plt.ylabel("Error")
    plt.xlabel("Time")

def ex2c():
    ############################################
    #                                          #
    #   ex2_c : Implement Sie diese Funktion   #
    #                                          #
    ############################################

    # TODO : Efuellen Sie den For-Schleife und ploten die Loesung

    T, N = 0.0, 0
    y0 = np.array([0., 0.0])

    all_methods = [explicit_euler, implicit_euler, implicit_mid_point]
    all_rhs = 3*[ODE_rhs]
    all_labels = ["ee", "ie", "im"]

    for ........... in zip(all_methods, all_rhs, all_labels):
        .............
        .............

    plt.savefig("methods_plot.eps")
    plt.show()

def ex2d():
    ############################################
    #                                          #
    #   ex2_d : Implement Sie diese Funktion   #
    #                                          #
    ############################################

    # TODO : Berechnen Sie die Loesung, den Fehler und ploten Sie den Fehler vs Resolution

    T = 0.
    y0 = np.array([0., 0.0])

    all_methods = [explicit_euler, implicit_euler, implicit_mid_point]
    all_rhs = 3*[ODE_rhs]
    all_labels = ["ee", "ie", "im"]
    resolutions = 1.

    _, y_exact = ode45(ODE_rhs, (0.0, T), y0, reltol=1e-12)

    for method, rhs, label in zip(all_methods, all_rhs, all_labels):
        error = np.empty(resolutions.size)
        for k, N in enumerate(resolutions):
            
            error[k] = 1.

        rate = convergence_rate(error, resolutions)
        print(method)
        print("rate: " + str(rate) + "\n")

    plt.savefig("methods_rate.eps")
    plt.show()

if __name__ == '__main__':
    
    #ex2c()
    #ex2d()
