# -*- coding: utf-8 -*-

import numpy as np
import scipy.optimize

def integrate(method, rhs, y0, T, N):
    y = np.empty((N+1,) + y0.shape)

    t0, dt = 0.0, T/N
    y[0,...] = y0
    for i in range(0, N):
        y[i+1,...] = method(rhs, y[i,...], t0 + i*dt, dt)

    t = np.arange(N+1)*dt
    return t, y

def explicit_euler_step(rhs, y0, t0, dt):
    ####################################################
    #                                                  #
    #            ex2_b: Implementieren Sie             #
    #            implizite Eulerverfahren              #
    #                                                  #
    ####################################################

    return 0.

def explicit_euler(rhs, y0, T, N):
    return integrate(explicit_euler_step, rhs, y0, T, N)

def implicit_euler_step(rhs, y0, t0, dt):
    ####################################################
    #                                                  #
    #            ex2_b: Implementieren Sie             #
    #            implizite Eulerverfahren              #
    #                                                  #
    ####################################################
    return 0.

def implicit_euler(rhs, y0, T, N):
    return integrate(implicit_euler_step, rhs, y0, T, N)

def implicit_mid_point_step(rhs, y0, t0, dt):
    ####################################################
    #                                                  #
    #            ex2_b: Implementieren Sie             #
    #           implizite Mittelpunktregel             #
    #                                                  #
    ####################################################
    return 0.

def implicit_mid_point(rhs, y0, T, N):
    return integrate(implicit_mid_point_step, rhs, y0, T, N)
